/*
 *	app.h
 *
 *	WSGvC[
 *
 *	* Fri Feb 20 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <clip.h>

#define Z80_CLOCK	3125000
#define WSG_CLOCK	  96000

#define MAX_TRACK	64

typedef struct _DRIVER {
	/*{{CAEgŒ*/
	Z80 z80;
	unsigned char mem[0x10000];
	/*}}CAEgŒ*/
	//
	WSG wsg;
	unsigned char wavetable[0x100];
	//
	int num_track;				/* gbN */
	unsigned short track[MAX_TRACK];	/* egbÑR}hAhX */
	//
	int nmi_interval;			/* NMIԊuTCN */
	int nmi_progress;			/* NMI܂ł̎cTCN */
} DRIVER;
extern DRIVER g_driver;

void z80_write(Z80* z80, unsigned short addr, unsigned char data);

typedef struct _ROMSET {
	int year;				/* N */
	const char* name;			/* Q[ */
	const char* file;			/* ROMZbgt@C (NULL:Ή) */
	const ROM* program_roms;		/* vOROM */
	int num_program_roms;			/* vOROM */
	const ROM* wavetable_roms;		/* WaveTable ROM */
	int num_wavetable_roms;			/* WaveTable ROM */
	int nmi_rate;				/* NMI/b */
	unsigned short track[MAX_TRACK];	/* egbÑR}hAhX */
	void (*init)(DRIVER* driver);		/* [` */
} ROMSET;

int file_sel(DRIVER* driver, int i_file);
void track_sel(DRIVER* driver, const ROMSET* romset);
void driver_play(DRIVER* driver, const ROMSET* romset, int i_track);
void driver_stop(DRIVER* driver, const ROMSET* romset);
int stream_callback(short wbuff[], int param);
void driver_mix(DRIVER* driver, short wbuff[/*WSGBUFLEN*/]);
void driver_mix2(DRIVER* driver, short wbuff[/*WSGBUFLEN*/]);

